local wk = require("whichkey_setup")

local keymap = {
	f = {
		name = "+file",
		f = { "<Cmd>Telescope file_browser<CR>", "browser" },
		t = { "<Cmd>NvimTreeToggle<CR>", "tree" },
	},

	b = {
		name = "+buffer",
		b = { "<Cmd>Telescope buffers<CR>", "buffers" },
	},

	q = {
		name = "+quickfix",
		o = { "<Cmd>copen<CR>", "open quickfix" },
		c = { "<Cmd>cclose<CR>", "close quickfix" },
	},

	p = {
		name = "+package",
		u = { "<Cmd>PackerUpdate<CR>", "update" },
		s = { "<Cmd>PackerSync<CR>", "sync" },
	},

	l = {
		name = "+lsp",

		a = { "<Cmd>lua vim.lsp.buf.code_action()<CR>", "code action" },
		r = { "<Cmd>lua vim.lsp.buf.rename()<CR>", "rename" },
		s = { "<Cmd>lua vim.lsp.buf.references()<CR>", "find" },
		p = { "<cmd>lua vim.lsp.buf.hover()<CR>", "preview definition" },
		f = { "<Cmd>lua vim.lsp.buf.format({ async = true })<CR>", "format" },
		d = { "<Cmd>lua vim.lsp.buf.definition()<CR>", "go to definition" },
		i = { "<Cmd>lua vim.lsp.buf.implementation()<CR>", "go to definition" },
		t = { "<Cmd>LspTroubleToggle lsp_workspace_diagnostics<CR>", "open LspTrouble" },
	},

	t = {
		name = "+telescope",

		p = { "<Cmd>Telescope project<CR>", "projects" },
		d = { "<Cmd>Telescope lsp_workspace_diagnostics<CR>", "diagnostics" },
	},
}

wk.register_keymap("leader", keymap)

-- b = {'<Cmd>Telescope buffers<CR>', 'buffers'},
-- h = {'<Cmd>Telescope help_tags<CR>', 'help tags'},
-- c = {
--     name = '+commands',
--     c = {'<Cmd>Telescope commands<CR>', 'commands'},
--     h = {'<Cmd>Telescope command_history<CR>', 'history'},
-- },
-- q = {'<Cmd>Telescope quickfix<CR>', 'quickfix'},
-- g = {
--     name = '+git',
--     g = {'<Cmd>Telescope git_commits<CR>', 'commits'},
--     c = {'<Cmd>Telescope git_bcommits<CR>', 'bcommits'},
--     b = {'<Cmd>Telescope git_branches<CR>', 'branches'},
--     s = {'<Cmd>Telescope git_status<CR>', 'status'},
-- },
