return require("packer").startup(function(use)
    use("wbthomason/packer.nvim")

    -- Color schemes
    use("morhetz/gruvbox")
    use("icymind/NeoSolarized")
    use("romgrk/doom-one.vim")
    use({
        "tjdevries/gruvbuddy.nvim",

        requires = { "tjdevries/colorbuddy.vim" },
        config = function()
            --require('colorbuddy').colorscheme('gruvbox')
            vim.cmd([[colo doom-one]])
        end,
    })

    -- UI
    use("ntpeters/vim-better-whitespace")
    use("Yggdroot/indentLine")
    use("haya14busa/incsearch.vim")
    use({
        "junegunn/fzf.vim",

        requires = { "junegunn/fzf" },
    })
    -- Look at feline for a leaner better maintained alternative.
    use({
        "glepnir/galaxyline.nvim",

        branch = "main",

        config = function()
            require("statusline")
        end,

        requires = { "kyazdani42/nvim-web-devicons" },
    })
    use("liuchengxu/vista.vim")
    use({
        "kyazdani42/nvim-tree.lua",
        requires = "kyazdani42/nvim-web-devicons",
        config = function()
            require("nvim-tree").setup({})
        end,
    })
    use({
        "AckslD/nvim-whichkey-setup.lua",
        requires = { "liuchengxu/vim-which-key" },
    })
    use({
        "akinsho/nvim-bufferline.lua",

        requires = "kyazdani42/nvim-web-devicons",

        config = function()
            require("bufferline").setup({})
        end,
    })
    use({
        "dnlhc/glance.nvim",
        config = function()
            require('glance').setup({
                height = 18, -- Height of the window
                zindex = 45,
                border = {
                    enable = false, -- Show window borders. Only horizontal borders allowed
                    top_char = '―',
                    bottom_char = '―',
                },
                list = {
                    position = 'right', -- Position of the list window 'left'|'right'
                    width = 0.33, -- 33% width relative to the active window, min 0.1, max 0.5
                },
                theme = { -- This feature might not work properly in nvim-0.7.2
                    enable = true, -- Will generate colors for the plugin based on your current colorscheme
                    mode = 'auto', -- 'brighten'|'darken'|'auto', 'auto' will set mode based on the brightness of your colorscheme
                },
                hooks = {},
                folds = {
                    fold_closed = '',
                    fold_open = '',
                    folded = true, -- Automatically fold list on startup
                },
                indent_lines = {
                    enable = true,
                    icon = '│',
                },
                winbar = {
                    enable = true, -- Available strating from nvim-0.8+
                },
            })
        end,
    })
    -- use({
    --     "folke/noice.nvim",
    --     config = function()
    --         require("noice").setup()
    --     end,
    --     requires = {
    --         -- if you lazy-load any plugin below, make sure to add proper `module="..."` entries
    --         "MunifTanjim/nui.nvim",
    --         -- OPTIONAL:
    --         --   `nvim-notify` is only needed, if you want to use the notification view.
    --         --   If not available, we use `mini` as the fallback
    --         "rcarriga/nvim-notify",
    --     }
    -- })

    -- use({
    --     "b0o/incline.nvim",
    --     config = function()
    --         require("incline").setup({
    --             debounce_threshold = { falling = 500, rising = 250 },
    --             render = function(props)
    --                 local bufname = vim.api.nvim_buf_get_name(props.buf)
    --                 local filename = vim.fn.fnamemodify(bufname, ":t")
    --                 local diagnostics = get_diagnostic_label(props)
    --                 local modified = vim.api.nvim_buf_get_option(props.buf, "modified") and "bold,italic" or "None"
    --                 local filetype_icon, color = require("nvim-web-devicons").get_icon_color(filename)

    --                 local buffer = {
    --                     { filetype_icon, guifg = color },
    --                     { " " },
    --                     { filename, gui = modified },
    --                 }

    --                 if #diagnostics > 0 then
    --                     table.insert(diagnostics, { "| ", guifg = "grey" })
    --                 end
    --                 for _, buffer_ in ipairs(buffer) do
    --                     table.insert(diagnostics, buffer_)
    --                 end
    --                 return diagnostics
    --             end,
    --         })
    --     end
    -- })

    -- Utilities
    use("editorconfig/editorconfig-vim")
    use({
        "nvim-treesitter/nvim-treesitter",

        run = ":TSUpdate",

        requires = {
            "nvim-treesitter/nvim-treesitter-refactor",
            "nvim-treesitter/nvim-treesitter-textobjects",
        },
    })

    use({
        "nvim-treesitter/playground",

        requires = {
            "nvim-treesitter/nvim-treesitter"
        }
    })
    use({
        "nvim-telescope/telescope.nvim",

        requires = {
            { "nvim-lua/popup.nvim" },
            { "nvim-lua/plenary.nvim" },
            { "nvim-telescope/telescope-project.nvim" },
        },

        config = function()
            require("telescope").load_extension("project")
        end,
    })
    use("Chiel92/vim-autoformat")
    use("Raimondi/delimitMate")
    use({
        "Shougo/echodoc.vim",

        config = function()
            vim.cmd([[let g:echodoc#enable_at_start=1]])
        end,
    })

    -- LSP
    use("neovim/nvim-lspconfig")
    use({
        "RishabhRD/nvim-lsputils",

        requires = { "RishabhRD/popfix" },
        disable = true,
    })
    use({
        "https://git.sr.ht/~whynothugo/lsp_lines.nvim",
        config = function()
            require("lsp_lines").setup()
        end,
    })

    use({
        "nvim-lua/lsp_extensions.nvim",

        requires = { "neovim/nvim-lspconfig" },

        disable = true,

        config = function()
            require("lsp_extensions").inlay_hints({
                highlight = "Comment",
                prefix = " » ",
                aligned = true,
                only_current_line = false,
                enabled = { "ChainingHint" },
            })
        end,
    })

    use('simrat39/inlay-hints.nvim')

    use('hashivim/vim-terraform')

    use({
        'simrat39/symbols-outline.nvim',

        config = require("symbols-outline").setup()
    })

    use({
        "rcarriga/nvim-dap-ui",
        requires = { "mfussenegger/nvim-dap" }
    })

    use({
        'yriveiro/dap-go.nvim',
        requires = { 'nvim-lua/plenary.nvim' }
    })

    use({
        "folke/lsp-trouble.nvim",
        disable = true,
        requires = "kyazdani42/nvim-web-devicons",
        config = function()
            require("trouble").setup({
                -- your configuration comes here
                -- or leave it empty to use the default settings
                -- refer to the configuration section below
            })
        end,
    })

    -- Completion
    use("onsails/lspkind-nvim")
    use("hrsh7th/cmp-buffer")
    use("hrsh7th/cmp-path")
    use("hrsh7th/cmp-nvim-lua")
    use("hrsh7th/cmp-nvim-lsp")
    use("hrsh7th/nvim-cmp")
    -- use({
    -- 	"dcampos/cmp-snippy",
    -- 	requires = {
    -- 		"dcampos/nvim-snippy",
    -- 		"honza/vim-snippets",
    -- 	},
    -- })

    use({
        "saadparwaiz1/cmp_luasnip",

        requires = {
            "L3MON4D3/LuaSnip",
        },
    })

    -- use({
    --     "rafamadriz/friendly-snippets",

    --     disable = true,
    --     requires = {
    --         "L3MON4D3/LuaSnip",
    --     },

    --     -- config = function()
    --     --     require("config.snip").setup()
    --     --     require("luasnip/loaders/from_vscode").load({
    --     --         paths = { "~/.local/share/nvim/site/pack/packer/start/friendly-snippets" },
    --     --     })
    --     -- end,
    -- })

    use("windwp/nvim-autopairs")

    use({
        "simrat39/rust-tools.nvim",

        requires = {
            "nvim-lua/popup.nvim",
        },
    })

    use({
        "scalameta/nvim-metals",
        requires = {
            "nvim-lua/plenary.nvim",
        },
    })

    use({
        "lewis6991/gitsigns.nvim",
        requires = {
            "nvim-lua/plenary.nvim",
        },
        config = function()
            require("gitsigns").setup()
        end,
    })

    use("tomlion/vim-solidity")
end)
